﻿#targetengine "g2t5"

//ドキュメントを開いていなければ終了
if(app.documents.length==0){
alert("InDesignドキュメントを開いてから実行してください。");
exit() ;
}

var doc=app.activeDocument;
var selObj = doc.selection;

//オブジェクトが選択されていなければ終了
if(selObj.length==0){
alert("オブジェクトを選択してから実行してください。");
exit();
}

//選択内にグループが含まれていたら終了
for (i=0; i<selObj.length; i++)
{
dType = selObj[i].constructor.name;
if(dType=="Group"){
alert("選択内にグループが含まれるので終了します。\r※ダイレクト選択ツールであれば選択可");
exit();
}
}

//変数を用意
var maxVal; //100
var minVal; //0
var maxValY;    //20
var minValY;    //120
var numBg;  //1

//前回の値を使えない場合は暫定値を使用
if (maxVal != null){
	maxVal=maxVal;
	}else{
			maxVal=100;
		}
if (minVal != null){
	minVal=minVal;
	}else{
			minVal=0;
		}
if (maxValY != null){
	maxValY=maxValY;
	}else{
			maxValY=20;
		}
if (minValY != null){
	minValY=minValY;
	}else{
			minValY=120;
		}
if (numBg != null){
	numBg=numBg;
	}else{
			numBg=1;
		}

//ダイアログで数値を設定
var myDiag=app.dialogs.add({name:"各項目を正しく入力してください"});
with (myDiag.dialogColumns.add()) {

with (borderPanels.add()){
staticTexts.add({staticLabel:"【1】最大目盛り：", minWidth:80});
maxVal=realEditboxes.add({editValue:maxVal, minWidth:80});
//staticTexts.add({staticLabel:"※"});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【2】最小目盛り：", minWidth:80});
minVal=realEditboxes.add({editValue:minVal, minWidth:80});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【3】最大目盛りY座標：", minWidth:80});
maxValY=realEditboxes.add({editValue:maxValY, minWidth:80});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【4】最小目盛りY座標：", minWidth:80});
minValY=realEditboxes.add({editValue:minValY, minWidth:80});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【5】グループ内の棒グラフ本数："});
numBg=realEditboxes.add({editValue:numBg, minWidth:80});
}

}
var flag2=myDiag.show();
if(flag2){}else{
maxVal = 100 ;
minVal = 0 ;
maxValY = 20 ;
minValY = 120 ;
numBg = 1 ;
exit()
};

maxVal=maxVal.editValue;	//【1】
minVal=minVal.editValue;	//【2】
maxValY=maxValY.editValue;	//【3】
minValY=minValY.editValue;	//【4】
numBg=numBg.editValue;	//【5】

var max2zero = maxVal/(maxVal-minVal)*(minValY-maxValY);    //最大値から0までの距離
var zeroY = maxValY+max2zero;   //0のY座標
var valuePerMm = maxVal / max2zero ; //1mmあたりの値
var columns = selObj.length/numBg;  //最終的なリストの列数
var rows = numBg;   //最終的なリストの行数
//オブジェクトの数が行数の整数倍になっていない場合は終了
if(selObj.length%numBg != 0 ){
alert("オブジェクト選択に過不足がないか確認してください");
exit();
}

//外部テキストファイルを用意
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime="-"+myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;
saveFolderPath = doc.filePath; // ドキュメントの保存フォルダ
var docName = app.documents[0].name.replace(/\.indd/g, "");
fileObj = new File(saveFolderPath +"/"+docName+"_g2t"+ nowTime+".txt");
fileObj.encoding="UTF8";

//値一覧を準備
var valueList=new String;
valueList=("");

//各グラフの値一覧を作成（順番は未整理／重なり順になってしまうので仕方がない）
var selX;   //X座標
var selValue;   //値
for(j=0; j<selObj.length; j++){
selX = selObj[j].geometricBounds[1];    //x座標
selValue = (zeroY - selObj[j].geometricBounds[0] ) * valuePerMm ;   //値
selValue = selValue.toFixed(2);
selValue=selValue.replace(/\.00/g, ""); 
valueList=(valueList+"\r"+selX+"\t"+selValue);
}

flag = fileObj.open("w");
if (flag){
fileObj.writeln(valueList);
fileObj.close();
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}

//値をx座標でソート
TAB = String.fromCharCode(9);	// タブコード
valueList=("");

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;

while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで分割
ary.push(txtItemA); //配列の最後に行を追加
countA++;
}

}
function funcCompare(a, b) {
	if (a[0]*1 < b[0]*1) return -1;
	if (a[0] *1> b[0]*1) return 1;
	return 0;
}
var newAry=ary.sort(funcCompare);
var aLength = newAry.length;
for( k=0 ; k<aLength ; k++ ){
var newTxt = newAry[k].join( "\t" );
valueList = valueList + newTxt + "\r" ;
}
valueList=valueList.replace(/\r[^\r]+?\t/g, "\r");  //x座標を削除
valueList=valueList.replace(/^\r/g, "");    //最初の改行を削除
valueList=valueList.replace(/\r/g, "\t");    //改行をタブに置換（1行に）

valueAry = valueList.split(TAB);	//　タブコードで分割
valueList=("");

//列×行の形にする
for(l=0 ; l<rows ; l++){
for(m=0 ; m<columns ; m++){
valueList=valueList+valueAry[m*numBg+l]+"\t";
}
valueList=valueList+"\r";
}
valueList=valueList.replace(/\t\r/g, "\r");    //不要なタブを削除

flag = fileObj.open("w");
if (flag){
fileObj.writeln(valueList);
fileObj.close();
}else{
alert("ファイルが作成できません。アクセス権があるか確認してください");
}